﻿/**
* @author Niels Bosma (niels.bosma@motorola.com
*/

var folder = Folder.selectDialog();
var document = app.activeDocument;

var black = new RGBColor();
black.red=0, black.green=0, black.blue=0;

var colors = [black];

if(document && folder)
{	
	var options = new ExportOptionsSVG();
	
	var artboards = document.artboards.length;
	var n = document.layers.length;
	
	
	var fill;
	for(var i=0; i<n; ++i)
	{
		hideAllLayers();
		var layer = document.layers[i];
		layer.visible = true;
		
		if(layer.pageItems.length==0) continue;
        
        exportSize(layer.pageItems[0], 4) 

	}
	
	showAllLayers();
}

function fillPath(pageItem, fillColor) {
		
		var type = pageItem.typename;
		
		switch(type)
		{
				case 'CompoundPathItem':
					for(var i=0; i<pageItem.pathItems.length; i++)
					{
							fillPath(pageItem.pathItems[i], fillColor);
					}
					break;
				case 'GroupItem':
					for(var i=0; i<pageItem.pageItems.length; i++)
					{
							fillPath(pageItem.pageItems[i], fillColor);
					}
					break;
				case 'PathItem':
					pageItem.fillColor=fillColor;
					break;
				default:
					alert(type);
		}
}

function exportSize(target, multiplier) {
	
	var oWidth=target.width;
	var oHeight=target.height;
    
    
    target.selected=true;
    copy();
    var docRef = documents.add();
    docRef.activate();
    paste();
    
    target=docRef.layers[0].pageItems[0];
	
	target.width*=multiplier;
	target.height*=multiplier;
	
	target.left=Math.round(target.left);
	target.top=Math.round(target.top);
    
	
	docRef.artboards[0].artboardRect=target.geometricBounds;
	
	var file = new File(folder.fsName+"/"+layer.name+".svg");
	
	var options = new ExportOptionsSVG();
	options.artBoardClipping = true;
	
	docRef.exportFile(file,ExportType.SVG,options);
    docRef.close();
    document.activate();
	
}

function hideAllLayers()
{
	forEach(document.layers, function(layer) {
		layer.visible = false;
	});
}

function showAllLayers()
{
	forEach(document.layers, function(layer) {
		layer.visible = true;
	});		
}

function forEach(collection, fn)
{
	var n = collection.length;
	for(var i=0; i<n; ++i)
	{
		fn(collection[i]);
	}
}